# //////////////////////////////////////////////////////////////////////////
# // dialog.tcl ////////////////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////

#
# //
# // Event Monitor Project
# // version 0.6
# //
# // Juan Manuel Casillas
# // assman@gsyc.inf.uc3m.es
# //
# //
# // Event Monitor Project
# //
# // dialog.tcl
# //
# //
# // shows some type of dialogs
# //
# // This program part of Event Monitor Project (EM), 
# // a system to manage and operate a heterogeneous 
# // network, based on message-passing.
# // See License file for details
# //
# // 
# //
#

# //////////////////////////////////////////////////////////////////////////
# // dialog ////////////////////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////

proc dialog {w title text bitmap default wlock args } {
  global button
  global FONT_MENU
  global FONT_SUBMENU
  global FONT_SSUBMENU
  global FONT_BUTTON

  set text_font $FONT_SUBMENU
  set button_font $FONT_BUTTON
  
    toplevel $w -class Dialog
  wm title $w $title
  wm iconname $w Dialog

  frame $w.top -relief raised -bd 1
  pack $w.top -side top -fill both
  frame $w.bot -relief raised -bd 1
  pack $w.bot -side bottom -fill both

  message $w.top.msg -width 3i -text $text\
	-font $text_font
  pack $w.top.msg -side right -expand 1 -fill both -padx 3m -pady 3m

  if { $bitmap != ""} {
	label $w.top.bitmap -bitmap $bitmap
        pack $w.top.bitmap -side left -padx 3m -pady 3m
  }

  set i 0
  foreach but $args {
      if { [ expr { $wlock == "0" } ] } {
	  button $w.bot.button$i -text $but \
	     -font $button_font \
	      -command "set button $i; destroy $w"

      } else {
	button $w.bot.button$i -text $but -command "set button $i" \
	     -font $button_font
      }

        if { $i == $default } {
  	     frame $w.bot.default -relief sunken -bd 1 
	     raise $w.bot.button$i
	     pack $w.bot.default -side left -expand 1 -padx 2 -pady 2
	     pack $w.bot.button$i -in $w.bot.default \
		-side left -padx 2 -pady 2 -ipadx 2m -ipady 1m
	} else {
	     pack $w.bot.button$i -side left -expand 1 -padx 2 -pady 2 \
		-ipadx 2m -ipady 1m
	}
	incr i
  }

  if {$default >= 0} {
	bind $w <Return> "$w.bot.button$default flash; set button $default"
  }
  set oldFocus [focus]
    if { [ expr { $wlock == "1" } ] } {  
	grab set $w
	focus $w
	tkwait variable button
	destroy $w
	focus $oldFocus
	return $button
    }
}


# dialog .d { Not respondig } { Pete del fileserver } {} -1 OK

#set i [dialog .d {File Modified} {File "fichero" ha sido modificado\
#desde la ultima actualizacion. Quieres salvar antes de salir\
#de la misma aplicacion?} warning 0 { Salvar } { Descartar } { Salir }]


# //////////////////////////////////////////////////////////////////////////
# // Dialog:Not_Implemented ////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////

proc Dialog:Not_Implemented { } {

dialog .d {Feature Not Implemented} \
{Sorry, this feature is not currently implemented !} \
warning -1 1 Acept
}

# //////////////////////////////////////////////////////////////////////////
# // Dialog:Exit  //////////////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////

proc Dialog:Exit { } {

set r [ dialog .d {Really Exit ?} \
{Do you really want to exit now ?} \
question 0  1 { Cancel } { Acept } ]

if { [ expr { $r == 1 } ] } {
 exit
}

}

# //////////////////////////////////////////////////////////////////////////
# // Dialog:New_Messages ///////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////

proc Dialog:New_Messages { num } {
    global WAIT_TIME
    global MAX_MSG_WARN
    global MAX_MSG_HEAT
    global MAX_MSG_PANIC

    set w .aviso
    set w_title "Hey You !" 
    set msg "You have $num new messages. Please READ them !"

    if { [ expr { $num > $MAX_MSG_WARN } ] } {

	if { [ expr { $num > $MAX_MSG_HEAT } ] } {
	    set w_title "What are you Doing ?"
	    set msg "Please, look at the console; you have $num new messages"
	}

	if { [ expr { $num > $MAX_MSG_PANIC } ] } {
	    set w_title "What FUCKING things are you Doing ?"
	    set msg "Hey man, you have $num fuck new messages, so if I were you,I should take a look to the console"
	}


	if { [ expr [ winfo exists .$w_title ] == "1" ] } {
	    destroy $w
	}
	set r [ dialog $w $w_title $msg warning 0 0 { Acept } ]
	
	after $WAIT_TIME destroy $w
	tkwait window $w

    }
}
