#!/usr/bin/tixwish
# ////////////////////////////////////////////////////////////////////////////////
# // node_manager.tcl ////////////////////////////////////////////////////////////
# ////////////////////////////////////////////////////////////////////////////////
#
# Este fichero implementa un conjunto de funciones para implementar
# una ventana que permita parsear una estructura de directorios con
# un contenido determinado para poder generar una estructura 
# jerrquica en la que almacenar los distintos valores
# Utilizo para ello la librerira TiX
# libreria TIX
#
# Variables Globales
# ^^^^^^^^^^^^^^^^^^
#
#       HOME_DIR
#       PIX_DIR 
#       icon_network
#       icon_harddisk
#       icon_default
#
#
# Procedimientos
# ^^^^^^^^^^^^^^
#
#	Login:Text { login passwd fich }   Comprueba si el login y el password
#					   existen en el fichero fich y son 
#					   iguales a los introducidos. devuelve
#	                                   1 en este caso (correcto) y 0 si no.				  
# 
#	Login:Check { fich }               Genera una nueva ventana y pide al
#                                          usuario el login y el password. En 
#                                          de pulsar cancelar, devuelve un 0, si
#                                          se pulsa aceptar y el login y el passwd
#                                          son validos, devuelve un uno. Se 
#                                          destruye la pantalla en caso de que la
#                                          autorizacion sea valida o se pulse
#                                          cancelar.
#
#
# POR HACER
#
#
#   * como leer los iconos y donde estan ....... resuelto
#   * usar pixmaps en vez de iconos ............ resuelto
#   * no dejar que se muevan ................... resuelto
#   * moduralizar .............................. resuelto
#   * problemas con el tamao de la ventana .... resuelto
#   * refrescar ................................ resuelto
#   * cambiarles el color 
#   * gestionar correctamente los iconos  
#   * etc etc
#
#
# ////////////////////////////////////////////////////////////////////////////////
# // version 0.1                //////////////////////////////////////////////////
# // jcasilla.madrid@sinvest.es //////////////////////////////////////////////////
# ////////////////////////////////////////////////////////////////////////////////

# ////////////////////////////////////////////////////////////////////////////////
# // Login:Test() ////////////////////////////////////////////////////////////////
# ////////////////////////////////////////////////////////////////////////////////


#!/usr/bin/tixwish

# intento leer un directorio y marcarmelo como iconos
# ademas, lo meto en una ventana de tipo scroll para 
# ir generando las ventanas



# //////////////////////////////////////////////////////////////////////////////
# // create_pixmaps ////////////////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////////

#
# create several compound images in the canvas
#

#    set HOME_DIR /home/assman/prac/em/tools/src/mio
    set HOME_DIR /home/consola/tools/src/mio
    set PIX_DIR $HOME_DIR

    set icon_network  [ image create pixmap -file $PIX_DIR/icons/Network.xpm ]
    set icon_harddisk [ image create pixmap -file $PIX_DIR/icons/ComputerPC.xpm ]
    set icon_default  [ image create pixmap -file $PIX_DIR/icons/TrashEmpty.xpm ]

    #     set network  [tix getimage network]
    #     set harddisk [tix getimage harddisk]
    #     set cmp_1 [ create_icon $c "pepe" $network ""  ]
    #     set cmp_2 [ create_icon $c "mas cositas" $harddisk "" ]
    #    set cmp_3 [ create_icon $c "xxxx" $harddisk "#c0c0ff" ]

# //////////////////////////////////////////////////////////////////////////////
# // create_icon() /////////////////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////////

proc create_icon { canvas name image background } {
    if { $background != "" } {

    set cmp_1 [image create compound -window $canvas -bd 1 \
		   -background $background -relief raised \
		   -showbackground 1]
    } else {
	set cmp_1 [image create compound -window $canvas -bd 1 ] 
    }
    $cmp_1 add image -image $image
    $cmp_1 add line
    $cmp_1 add text -text $name
    return $cmp_1
}
    


# //////////////////////////////////////////////////////////////////////////////
# // scan_tree() ///////////////////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////////

proc scan_tree { TOP IN_USE } {

   # extract node name and put in on the window

   set arr [ split $IN_USE / ]
   set ll [ llength $arr ]
   set w_title [ lindex $arr [ expr $ll - 1] ]

   #
   # test if if exists new node
   # here is necesary check if 
   # its a file or a directory
   
   if { [ expr [ catch { exec /bin/ls $IN_USE } ] == "1" ] } {
       return
   }

   # 
   # generate new window
   # test if exists the same window
   # yet
   #

    if { [ expr [ winfo exists .$w_title ] == "0" ] } {
     set w .$w_title
     toplevel $w
     wm title $w $w_title
    } else {
	return 
    }

   # 
   # generate the countour window and button window
   #

   set top [frame $w.f -bd 1 -relief raised]
   set box [tixButtonBox $w.b -bd 1 -relief raised]


   pack $box -side bottom -fill both
   pack $top -side top -fill both -expand yes

   label $top.lab -text "Working on $w_title"
   pack $top.lab -anchor c -side top -pady 4 

   #
   # Create the canvas to display the icons
   #

   #tixScrolledWindow $top.sw  
   #pack $top.sw -expand yes -fill both 
   #set f [$top.sw subwidget window]

   refresh_data $top $w_title $TOP $IN_USE

   #
   # make bindings
   # and pack the rest of the items
   #

   #bind $c <3>         "itemStartDrag $c %x %y"
   #bind $c <B3-Motion> "itemDrag $c %x %y"

   #
   # Create the buttons
   #

    $box add ok     -text Ok     -command "destroy $w " -width 6
    $box add cancel -text Cancel -command "destroy $w;exit" -width 6


}



# //////////////////////////////////////////////////////////////////////////////
# // refresh_data() ////////////////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////////

proc refresh_data { top w_title TOP IN_USE } {
   global icon_harddisk icon_network icon_default

    #
    # if not exists the window, bail out
    #

    if { [ expr [ winfo exists .$w_title ] == "0" ] } {
	return 
    } 

    destroy $top.c  
    destroy $top.sy 
    destroy $top.sx 

   set c [canvas $top.c -relief sunken -bd 1 \
	      -yscrollcommand "$top.sy set" \
	      -xscrollcommand "$top.sx set" ]

   scrollbar $top.sy -command "$c yview" 
   scrollbar $top.sx -orient horizontal -command "$c xview" 
   pack $top.sy -side right -fill y
   pack $top.sx -side bottom -fill x
   pack $c -side top -fill both -expand yes

   # ------------- important code is here -------------------------------
   #
   # scan tree and insert icons on it
   # this in only for debug pourpouses 
   # only and must bye redo
   #
   # now, we try to put the icons in some good lookin position
   #
   #

   set BX 50
   set BY 50
   set XS 80
   set YS 80
   set row 0
   set col 0 
   set MX_COL [ expr [ winfo screenwidth .$w_title ] / 300 ]

   set array [ exec /bin/ls $IN_USE  ]
   set i [ llength $array ]
   set p 0

   while { $p < $i } {

    set icon [ create_icon $c [ lindex $array $p ] $icon_harddisk "" ]
    set xx [ expr ($col * $XS) + $BX ]
    set yy [ expr ($row * $YS) + $BY ]
    if { [ expr $col > $MX_COL ]} {
	incr row
	set  col 0
	set xx [ expr ($col * $XS) + $BX ]
	set yy [ expr ($row * $YS) + $BY ]
    }
    # set k [ expr $p * 50]
    $c create image $xx $yy -image $icon -tag [ lindex $array $p ]
    incr p
    incr col
   }

   #
   #
   # last inserta a 
   # default icon here
   #
   # ------------- important code end here -------------------------------

    set icon [ create_icon $c "default" $icon_default "" ]
    set xx [ expr ($col * $XS) + $BX ]
    set yy [ expr ($row * $YS) + $BY ]
    if { [ expr $col > $MX_COL ]} {
	incr row
	set  col 0
	set xx [ expr ($col * $XS) + $BX ]
	set yy [ expr ($row * $YS) + $BY ]
    }
    # set k [ expr $p * 50]
    $c create image $xx $yy -image $icon -tag [ lindex $array $p ]
   
 
    

    bind $c <1>         "exam $c $TOP $IN_USE"

   after 2000 "refresh_data $top $w_title $TOP $IN_USE" 
}

# //////////////////////////////////////////////////////////////////////////////
# // exam() ////////////////////////////////////////////////////////////////////
# //////////////////////////////////////////////////////////////////////////////

proc exam { w TOP IN_USE } {
    #
    # extract the next-level-label 
    #
    
    set next [ lindex [ $w gettags current ] 0 ]
    set IN_USE $IN_USE/$next
    scan_tree $TOP $IN_USE

    #toplevel .info
    #label .info.l -text 
    #button .info.b -text Ok -command "destroy .info"
    #pack .info.l
    #pack .info.b
}


#
# ---- Real Code here -------
#

wm withdraw .

set TOP $HOME_DIR/main
set CURRENT $TOP

scan_tree $TOP $CURRENT




#
# misc procs to test the move
#

proc itemStartDrag {c x y} {
    global lastX lastY
    $c raise current

    set lastX [$c canvasx $x]
    set lastY [$c canvasy $y]
}

#
# more movement procs
#

proc itemDrag {c x y} {
    global lastX lastY
    set x [$c canvasx $x]
    set y [$c canvasy $y]
    $c move current [expr $x-$lastX] [expr $y-$lastY]
    set lastX $x
    set lastY $y
}

