/* //////////////////////////////////////////////////////////////////////// */
/* // emtlog.c //////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

//
// Event Monitor Project
// version 0.6
//
// Juan Manuel Casillas
// assman@gsyc.inf.uc3m.es
//
//
// 
// emtlog [ Aka Event Monitor Transaction Logger ]
//
// this programs lets you manage, syncronize and merge message files
// and, in the other side, it lets you move checked messages to a 
// historical file 
//
// This program is part of Event Monitor project (EM), 
// a system to manage and operate a heterogeneous 
// network, based on message-passing.
// See License file for details
//
//
// Usage: emtlog <id-of-message-to-move> 
//        emtlog
//


#include <sys/sem.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <string.h>
#include <strings.h>

#include "libem.h"

/* //////////////////////////////////////////////////////////////////////// */
/* // load() ////////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

void load(char *NFLOG, char *IF,char *OF,char *SF,char *HF,char *TF, char *WF){
char cad[MAX_CAD];

FILE *f=NULL;
f=fopen(NFLOG,"r");
if (f==NULL) error(9,NFLOG);

bzero(IF,MAX_CAD);
bzero(OF,MAX_CAD);
bzero(SF,MAX_CAD);
bzero(HF,MAX_CAD);
bzero(TF,MAX_CAD);
bzero(WF,MAX_CAD);

   read_cad(f,cad); if (sscanf(cad,"%s",IF)!=1)	error(8,NFLOG);
   read_cad(f,cad); if (sscanf(cad,"%s",OF)!=1) error(8,NFLOG);
   read_cad(f,cad); if (sscanf(cad,"%s",SF)!=1) error(8,NFLOG);
   read_cad(f,cad); if (sscanf(cad,"%s",HF)!=1) error(8,NFLOG);
   read_cad(f,cad); if (sscanf(cad,"%s",TF)!=1) error(8,NFLOG);
   read_cad(f,cad); if (sscanf(cad,"%s",WF)!=1) error(8,NFLOG);

fclose(f);
}


/* /////////////////////////////////////////////////////////////////////// */
/* / create_sem() //////////////////////////////////////////////////////// */
/* /////////////////////////////////////////////////////////////////////// */

int create_sem(void) {
return(semget ( SEM_KEY, SEM_NUM ,IPC_CREAT|0777));
}

/* /////////////////////////////////////////////////////////////////////// */
/* / remove_sem() //////////////////////////////////////////////////////// */
/* /////////////////////////////////////////////////////////////////////// */

void remove_sem(int sid) {
// int v;
// semctl(sid,0,IPC_RMID,v);
}

/* /////////////////////////////////////////////////////////////////////// */
/* / get_sem() /////////////////////////////////////////////////////////// */
/* /////////////////////////////////////////////////////////////////////// */

int get_sem(int sid) {
  /* int v;
     return(semctl(sid,0,GETVAL,v)); */
// return(semctl(sid,0,GETVAL));
return(0);
}

/* /////////////////////////////////////////////////////////////////////// */
/* / inc_sem() /////////////////////////////////////////////////////////// */
/* /////////////////////////////////////////////////////////////////////// */

int inc_sem(int sid) {
int v;
v=get_sem(sid);
v++;
//semctl(sid,0,SETVAL,&v);
return(v);
}

/* /////////////////////////////////////////////////////////////////////// */
/* / dec_sem() /////////////////////////////////////////////////////////// */
/* /////////////////////////////////////////////////////////////////////// */

int dec_sem(int sid) {
int v;
v=get_sem(sid);
v--;
if (v<0) v=0;
//semctl(sid,0,SETVAL,&v);
return(v);
}

/* /////////////////////////////////////////////////////////////////////// */
/* / write_trans() /////////////////////////////////////////////////////// */
/* /////////////////////////////////////////////////////////////////////// */

void write_trans(char *TF, int value) {
FILE *If;
 if (value>=0) {
 If=fopen(TF,"a");        
 fprintf(If,"%d\n",value);
 fclose(If); 
 }
}


/* /////////////////////////////////////////////////////////////////////// */
/* / test_sem() ////////////////////////////////////////////////////////// */
/* /////////////////////////////////////////////////////////////////////// */

int test_sem(int sid, char *TF, int value) {
int v;
int ok=0;
v=get_sem(sid);
write_trans(TF,value);
while (v>0) {
ok=1;
sleep(SLEEP_TIME);
v=get_sem(sid);
}
inc_sem(sid);
return(ok);
}



/* /////////////////////////////////////////////////////////////////////// */
/* / load_from_spool() /////////////////////////////////////////////////// */
/* /////////////////////////////////////////////////////////////////////// */

void load_from_spool(char *SF, char *IF) {
FILE *If=NULL;
FILE *of=NULL;
char string[MAX_CAD];

 If=fopen(SF,"r"); // lectura
 of=fopen(IF,"a"); // escritura

 if (of==NULL) {
   of=fopen(IF,"w");
 }   

 if (If==NULL) return;

 while (!feof(If)) {
   bzero(string,sizeof(string));
   fgets(string,MAX_CAD,If);
   if (strlen(string)==0) break;
   fprintf(of,"%s",string);
 }

 fclose(If);
 fclose(of);
 
 If=fopen(SF,"w");
 fclose(If);
}

/* /////////////////////////////////////////////////////////////////////// */
/* / delete_row() //////////////////////////////////////////////////////// */
/* /////////////////////////////////////////////////////////////////////// */

void delete_row(char *IF, char *WF, char *HF, long TRANS) {
int l=0;
FILE *If=NULL;
FILE *Of;
FILE *Hf;
char string[MAX_CAD];
long NTRANS;

 if (TRANS<0) return;
     
 If=fopen(IF,"r");        
 Of=fopen(WF,"w");
  // printf("reading from %s\n",IF);
  // printf("writing on %s\n",WF);
 
 if (If==NULL) {
   fclose(If);
   fclose(Of);
   remove(WF);
 }
 else {
 while (!feof(If)) {
   bzero(string,sizeof(string));

      fgets(string,MAX_CAD,If);
   // puts("parsing string");
   sscanf(string,"%ld",&NTRANS);
   // puts("parsing done");

  /*    printf("String [%s](%d)\n",string,l); */
   if (strlen(string)==0) break;
   if (TRANS!=NTRANS) {
     fprintf(Of,"%s",string);
   } else {
     Hf=fopen(HF,"a");
     fprintf(Hf,"%s",string);
     fclose(Hf);
   }
   l++;
 }
 fclose(If); 
 fclose(Of);
 remove(IF);
 rename(WF,IF);
 }
}

/* /////////////////////////////////////////////////////////////////////// */
/* / sync_file() ///////////////////////////////////////////////////////// */
/* /////////////////////////////////////////////////////////////////////// */

void sync_file(char *IF, char *OF, char *SF, 
	       char *HF, char *TF, char *WF, long TRANS) {
//FILE *FF=NULL;
//int trans;
//int T_ARRAY[MAX_TRANS];
//int i;
//int last=0;

// FF=fopen(TF,"r");        
// if (FF==NULL) {

     //   fclose(FF);
// } else {

 // load transactions 
   /* printf("opening %s\n",TF); */

// while (!feof(FF)) {
//   if (fscanf(FF,"%d",&trans)<0) break;

//   for (i=0; i<last; i++) {
//     if (trans==T_ARRAY[i]) break;
//   }
//   if (i==last) {
//     T_ARRAY[last]=trans;
//     last++;
//   }
// }
// fclose(FF);
// remove(TF);

 // apply them

// for (i=0; i<last; i++) {
   /*   printf("deleting row %d\n",T_ARRAY[i]); */
//  delete_row(IF,WF,HF,T_ARRAY[i);
// }
// }
 // move spool

 delete_row(IF,WF,HF,TRANS); 
 load_from_spool(SF,IF);
   
}

/* /////////////////////////////////////////////////////////////////////// */
/* / main() ////////////////////////////////////////////////////////////// */
/* /////////////////////////////////////////////////////////////////////// */

void main(int argc, char *argv[]) {
long TRANS;
// int mysem;
char IF[MAX_CAD];
char OF[MAX_CAD];
char SF[MAX_CAD];
char HF[MAX_CAD];
char TF[MAX_CAD];
char WF[MAX_CAD];
char *NFLOG=NULL;

NFLOG=getenv(ENV_VAR_DIR);
if (NFLOG!=NULL) load(NFLOG,IF,OF,SF,HF,TF,WF);
else load(CFILE,IF,OF,SF,HF,TF,WF);

     if (argc>=2) {
	  TRANS=atol(argv[1]);
    } else TRANS=-1;

 //mysem=create_sem();
 //if (!test_sem(mysem,TF,TRANS)) {
  sync_file(IF,OF, SF, HF, TF, WF, TRANS);
  // }

  //dec_sem(mysem);
  //remove_sem(mysem);
}
